<!-- 选择所依据的技术文件（/资源管理/技术文件/现行测试校准检定方法） -->
<script lang="ts" setup name="SelectTechFiles">
import { ElMessage } from 'element-plus'
import type { Ref } from 'vue'
import { ref } from 'vue'
import dayjs from 'dayjs'
import type { TableColumn } from '../../../../../components/NormalTable/table_interface'
import { getFileMethodList } from '@/api/resource/fileTechnology'
import { getDictByCode } from '@/api/system/dict'
import type { dictType } from '@/global'

const emits = defineEmits(['confirm'])
const dialogFormVisible = ref(false)
// 查询条件
const listQuery = ref({
  fileNo: '', // 文件编号
  fileName: '', // 文件名
  fileDistributeNo: '', // 文件发放号
  professionalGroup: '', // 专业组
  offset: 1,
  limit: 5,
})
// 多选选中的内容
const checkoutList = ref([]) // 选中
const loadingTable = ref(false) // loading
const list = ref([]) // 表格数据
const total = ref(0) // 数据条数
const columns = ref<TableColumn[]>([
  { text: '文件编号', value: 'fileNo', align: 'center', width: '160' },
  { text: '文件发放号', value: 'fileDistributeNo', align: 'center' },
  { text: '文件名称', value: 'fileName', align: 'center' },
  { text: '版本号', value: 'versionNo', align: 'center' },
  { text: '专业组', value: 'professionalGroupName', align: 'center', width: '140' },
  { text: '启用时间', value: 'activeDateStr', align: 'center', width: '120' },
])

// 数据查询
function fetchData(isNowPage = false) {
  loadingTable.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.value.offset = 1
  }
  getFileMethodList(listQuery.value).then((response) => {
    if (response.code === 200) {
      list.value = response.data.rows.map((item: { activeDate: string }) => {
        return {
          ...item,
          activeDateStr: dayjs(item.activeDate).format('YYYY-MM-DD') !== 'Invalid Date' ? dayjs(item.activeDate).format('YYYY-MM-DD') : '',
        }
      })
      total.value = parseInt(response.data.total)
    }
    loadingTable.value = false
  }).catch(() => {
    loadingTable.value = false
  })
}
// 重置
const clearList = () => {
  listQuery.value = {
    fileNo: '', // 文件编号
    fileName: '', // 文件名
    fileDistributeNo: '', // 文件发放号
    professionalGroup: '', // 专业组
    offset: 1,
    limit: 20,
  }
  fetchData()
}
// 搜索
const search = () => {
  fetchData(true)
}
// 多选选中
const handleSelectionChange = (val: any) => {
  checkoutList.value = val
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number;page?: number }) => {
  if (val && val.size) {
    listQuery.value.limit = val.size
  }
  if (val && val.page) {
    listQuery.value.offset = val.page
  }
  search()
}
// 点击确定
const confirmSelect = () => {
  if (!checkoutList.value.length) {
    ElMessage.warning('请选中')
  }
  else {
    emits('confirm', checkoutList.value)
    dialogFormVisible.value = false
  }
}
// 取消
const resetForm = () => {
  dialogFormVisible.value = false
  clearList()
}

// -----------------------------------------字典-----------------------------------------------
const professGroupDict = ref<dictType[]>([]) // 专业组
// 获取文件类别字典值
const getDict = () => {
  getDictByCode('bizGroupCode').then((res) => {
    if (res.code === 200) {
      professGroupDict.value = res.data
    }
  })
}
// --------------------------------------------------------------------------------------------

// 初始化
const initDialog = async () => {
  await getDict()
  dialogFormVisible.value = true
  fetchData()
}

defineExpose({ initDialog })
</script>

<template>
  <el-dialog v-if="dialogFormVisible" v-model="dialogFormVisible" title="选择技术文件" width="65%">
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="clearList">
      <search-item>
        <el-input v-model="listQuery.fileNo" placeholder="文件编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model="listQuery.fileDistributeNo" placeholder="文件发放编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model="listQuery.fileName" placeholder="文件名称" clearable />
      </search-item>
      <search-item>
        <el-select v-model="listQuery.professionalGroup" placeholder="专业组" clearable>
          <el-option v-for="item in professGroupDict" :key="item.id" :value="item.value" :label="item.name" />
        </el-select>
      </search-item>
    </search-area>

    <!-- 查询结果Table显示 -->
    <div style="padding: 12px;">
      <normal-table
        :data="list"
        :total="total"
        :columns="columns"
        :query="listQuery"
        :is-showmulti-select="false"
        :list-loading="loadingTable"
        :is-multi="false"
        :height="260"
        :page-sizes="[5]"
        @change="changePage"
        @multi-select="handleSelectionChange"
      >
        <!-- 序号 -->
        <template #preColumns>
          <el-table-column label="#" width="55" align="center" fixed>
            <template #default="scope">
              {{ (listQuery.offset - 1) * listQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </div>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="confirmSelect">确认</el-button>
        <el-button @click="resetForm">
          取消
        </el-button>
      </span>
    </template>
  </el-dialog>
</template>

<style lang="scss" scoped>
:deep(.el-radio__label) {
  display: none;
}
</style>
